package bytecode;

import static org.junit.Assert.*;

import java.io.File;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;

import org.junit.BeforeClass;
import org.junit.Test;

import de.dhbwstuttgart.core.JavaTXCompiler;

public class FieldTphConsMethTest {

	private static String path;
	private static File fileToTest;
	private static JavaTXCompiler compiler;
	private static ClassLoader loader;
	private static Class<?> classToTest;
	private static String pathToClassFile;
	private static Object instanceOfClass;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		path = System.getProperty("user.dir")+"/src/test/resources/bytecode/javFiles/FieldTphConsMeth.jav";
		fileToTest = new File(path);
		compiler = new JavaTXCompiler(fileToTest);
		compiler.generateBytecode(System.getProperty("user.dir")+"/src/test/resources/testBytecode/generatedBC/");
		pathToClassFile = System.getProperty("user.dir")+"/src/test/resources/testBytecode/generatedBC/";
		loader = new URLClassLoader(new URL[] {new URL("file://"+pathToClassFile)});
		classToTest = loader.loadClass("FieldTphConsMeth");
	}
	
	@Test
	public void test() throws Exception {
		instanceOfClass = classToTest.getConstructor(Object.class).newInstance("C");
		Field a = classToTest.getDeclaredField("a");
		a.setAccessible(true);
		
		Method m = classToTest.getDeclaredMethod("m", Object.class);
		Object result = m.invoke(instanceOfClass, 42);
		
		assertEquals(42,result);
		assertEquals("C", a.get(instanceOfClass));
	}

}
